// Ce programme est en rapport avec la question 1.

// Il affiche les représentations binaires de x0+epsilon^i et
// x0-epsilon^i pour x0=0.375 et epsilon=0.25. On arrête quand
// il y a moins de 1024 valeurs représentables entre les deux.

// Attention, ça ne fonctionne pas pour n'importe quelles valeurs
// de x0 et epsilon, c'est un calcul simplifié basé sur le fait
// que l'exposant se stablise.

#include <stdio.h>

// remplacer 0 par 1 pour utiliser le type double plutôt que float
#define DOUBLE 1

void output_bit (unsigned char c) { printf(c? "1" : "0"); }

void output_byte (unsigned char c)
{
	output_bit(c & 0x80); output_bit(c & 0x40);
	output_bit(c & 0x20); output_bit(c & 0x10);
	printf(" ");
	output_bit(c & 0x08); output_bit(c & 0x04);
	output_bit(c & 0x02); output_bit(c & 0x01);
	printf(" ");
}

void output_double (char *prefix, double x)
{
	unsigned char *c = ((unsigned char*)(&x))+7;
	fputs(prefix,stdout);
	output_byte(*c--); output_byte(*c--);
	output_byte(*c--); output_byte(*c--);
	output_byte(*c--); output_byte(*c--);
	output_byte(*c--); output_byte(*c--);
	printf("\n");
}

void output_float (char *prefix, float x)
{
	unsigned char *c = ((unsigned char*)(&x))+3;
	fputs(prefix,stdout);
	output_byte(*c--); output_byte(*c--);
	output_byte(*c--); output_byte(*c--);
	printf("\n");
}

/////  pour float  /////////////////////////////////////////////////

void resultat_float ()
{
	int i = 1;
	int width = 1024;

	float x0 = 0.375;
	float epsilon = 0.25;
	float factor = 0.25;
	float xmin, xmax;
	unsigned int *imin = (unsigned int*)(&xmin);
	unsigned int *imax = (unsigned int*)(&xmax);

	output_float("  x0: ",x0);
	printf("\n");

	do {
		xmin = x0 - epsilon; xmax = x0 + epsilon;

		printf("iteration i = %d\n",i);
		printf("  [xmin,xmax,eps] = [%f,%f,%f]\n",xmin,xmax,epsilon);
		output_float("  xmax: ",xmax);
		output_float("  xmin: ",xmin);
		output_float("  eps : ",epsilon);
		printf("  diff: %d\n\n",*imax-*imin);
		
		epsilon *= factor;
		i++;
	} while (*imax-*imin >= width);
	
}

/////  pour double  /////////////////////////////////////////////////

void resultat_double ()
{
	int i = 1;
	int width = 1024;

	double x0 = 0.375;
	double epsilon = 0.25;
	double factor = 0.25;
	double xmin, xmax;
	unsigned long int *imin = (unsigned long int*)(&xmin);
	unsigned long int *imax = (unsigned long int*)(&xmax);

	output_double("  x0: ",x0);
	printf("\n");

	do {
		xmin = x0 - epsilon; xmax = x0 + epsilon;

		printf("iteration i = %d\n",i);
		printf("  [xmin,xmax,eps] = [%f,%f,%f]\n",xmin,xmax,epsilon);
		output_double("  xmax: ",xmax);
		output_double("  xmin: ",xmin);
		output_double("  eps : ",epsilon);
		printf("  diff: %ld\n\n",*imax-*imin);
		
		epsilon *= factor;
		i++;
	} while (*imax-*imin >= width);
}

/////  main  /////////////////////////////////////////////////

int main ()
{
#if DOUBLE
	resultat_double();
#else
	resultat_float();
#endif
	return 0;
}
