// Solution pour la Question 4b, avec K sémaphores pour N=2^K threads.

#include <pthread.h>
#include <stdio.h>
#include <semaphore.h>

#define K 4
#define N (1<<K)

pthread_t th[N];
sem_t s[K];

// Libérer un sémaphore plusieurs fois.
void multipost (sem_t *sem, int n)
{
	int i;
	for (i = 0; i < n; i++) { sem_post(sem); }
}

void* thread (void *arg)
{
	int i;
	long int id = (long int) arg;

	// On attend les sémaphores correspondant aux bits de 1
	// dans l'écriture binaire d'id, du MSB au LSB.

	for (i = K-1; i >= 0; i--)
		if (id & (1<<i)) sem_wait(s+i);

	printf("%ld\n",id);

	// Déterminer le bit le plus faible qui est 0.
	// (marche aussi avec la méthode De Bruijn)
	for (i = 0; id & (1<<i); i++);

	// Libérer le i-ème sémaphore 2^i fois.
	if (i < K) multipost(s+i,1<<i);

	return NULL;
}

int main ()
{
	// initialiser les sémaphores
	long int i;
	for (i = 0; i < K; i++) sem_init(s+i,0,0);

	// lancer les threads
	for (i = 0; i < N; i++)
		pthread_create(th+i,NULL,thread,(void*)i);

	// ramasser tous les threads
	for (i = 0; i < N; i++)
		pthread_join(th[i],NULL);

	return 0;
}
