// Solution pour la Question 4c. Les threads se comportent
// comme dans 4b, puis ils reprennent après tout le monde
// ait fini.

#include <pthread.h>
#include <stdio.h>
#include <semaphore.h>

#define K 6
#define N (1<<K)

pthread_t th[N];
sem_t s[K];
sem_t q1,q2,r1,r2;

// Libérer un sémaphore plusieurs fois
void multipost (sem_t *sem, int n)
{
	int i;
	for (i = 0; i < n; i++) { sem_post(sem); }
}

void* thread (void *arg)
{
	int i;
	long int id = (long int) arg;

	while (1)
	{
		// Le même comportement que pour 4b.
		for (i = K-1; i >= 0; i--)
			if (id & (1<<i)) sem_wait(s+i);

		printf("%ld\n",id);

		for (i = 0; id & (1<<i); i++);
		if (i < K) multipost(s+i,1<<i);

		// Signaliser à main qu'on est prêt (q1) et attendre
		// que tout le monde l'est.
		sem_post(&q1); sem_wait(&r1);

		// Et encore une fois.
		sem_post(&q2); sem_wait(&r2);
	}
}

int main ()
{
	long int i;

	// initialiser les sémaphores
	for (i = 0; i < K; i++) sem_init(s+i,0,0);
	sem_init(&q1,0,0); sem_init(&q2,0,0);
	sem_init(&r1,0,0); sem_init(&r2,0,0);

	// lancer les threads
	for (i = 0; i < N; i++)
		pthread_create(th+i,NULL,thread,(void*)i);

	while (1)
	{
		// Attendre que tous les threads ont fait leur tour.
		for (i = 0; i < N; i++) sem_wait(&q1);
		// Signaler ce fait à tout le monde.
		multipost(&r1,N);

		// Et encore une fois.
		for (i = 0; i < N; i++) sem_wait(&q2);
		multipost(&r2,N);
	}
}
